<?php if (!defined('PmWiki')) exit();
/**
 * qnotes.include.php
 * @author V.Krishn (vkrishn@insteps.net), Copyright 2010-2019
 * @note This file is part of Cookbook recipe "QNotes" for PmWiki;
 * You can redistribute it and/or modify it under the terms of the
 * GNU General Public License as published by the  Free Software
 * Foundation; either version 2 of the License, or (at your option)
 * any later version. @see pmwiki.php for full details.
 * @package qnotes
 */

// **********************************************************
// Links to nodes/qnotes
// **********************************************************
//(:qnotes include 'QNotes.Notes1' '/default' showchild=0
    //showtitle=0 showtext=0 showcomment=0 class='' id='' wrap='none':)

    global $QNotes;

    $qnDrawType = &$args[''][0];
    $qnp = &$args[''][1];
    $qn = &$args[''][2];
    $showtitle = $args['showtitle'];
    $showtext = $args['showtext'];
    $showcomment = $args['showcomment'];
    $wrap = &$args['wrap'];
    $showchild = $args['showchild'];
    $id = $args['id'];
    $class = $args['class'];

    if($args['class']) { $cl = "class='qnoteinclude ".$class."'"; } else { $cl = "class='qnoteinclude'"; }
    if(trim($id)) { $id = "id='$id'"; }

    $t= $qnp.'::'.$qn;

    if(is_array($QNotes['linkscyc']) && count($QNotes['linkscyc']) == 1) {
      $qnotesOutFmt = $QNotes['qnotesSelfLink']; //self links
    } else {
      $qnotesOutFmt = $QNotes['qnotesRecursiveLink']; //cyclic links
    }
    if(is_array($QNotes['linkscyc']) && in_array($t, $QNotes['linkscyc'])) {
      unset($QNotes['linkscyc']); return; //stops cyclic links
    }
    $QNotes['linkscyc'][] = $t;

    //$GLOBALS['RedoMarkupLine']++;
    if(PageExists($qnp)) {
      $page = qnotes_get_page($qnp);
      if($showchild === '1') {
        $temp = qnotes_node_get_bycategory($qnp, $qn, $page);
        $qnotesOutFmt = $temp[0];
      } else {
        $qnotesOutFmt = trim(qnotes_nodetext_get_bycategory($qnp, $qn, $page, 0));
      }
    } else {
      $qnotesOutFmt = $QNotes['qnotesPageNotFound'];
    }
    if( ! trim($qnotesOutFmt)) $qnotesOutFmt = $QNotes['qnotesNoteNotFound'];

    //filters
    $qnts = '(!+.*?)(\\(:div490\\s+?class=.*?:\\))(.*?)'.$QNotes['qnte']; //@todo - move to $QNotes array.
    if($showcomment === '0') {
      $qnotesOutFmt = preg_replace('/'.$QNotes['qncmb'].'/si', '', $qnotesOutFmt);
    }
    if($showchild === '1') {
      //@todo
    } else {
      if($showtitle === '0') {
        preg_match("/$qnts/si", $qnotesOutFmt, $m);
        $qnotesOutFmt = $m[2].$m[3].$m[4];
      }
      if($showtext === '0') {
        preg_match("/$qnts/si", $qnotesOutFmt, $m);
        $qnotesOutFmt = $m[1];
      }
    }
    if($wrap === 'none') {
      $qnotesOutFmt = $qnotesOutFmt;
    } else {
      $qnotesOutFmt = "\n(:div500 " . @$id . $cl .":)\n" . $qnotesOutFmt . "\n(:div500end:)";
    }

    $qnotesOutFmt = Keep(MarkupToHTML($qnp, $qnotesOutFmt));
    unset($QNotes['linkscyc']);

    return;

